<template>
  <div class="q-pa-md" style="background: transparent;">
    <div class="row justify-center" style="background: transparent">
      <div class="col" style="width: 100%; max-width: 400px">
        <div class="cui-login-block-form" style="background: white; padding: 0 auto 0 auto">
          <h3 style="font-size: 1.75rem; margin: 0 auto 0 10px"><strong>Registrasi</strong></h3>

          <form v-on:submit.prevent="doRegister">
            <input type="hidden" name="submit" value="submit">
            <div class="form-group">
              <q-input v-model="email" label="Email" placeholder="Masukan Alamat Email" :dense="dense" />
              <q-input v-model="nama" label="Nama Lengkap" placeholder="Masukan Nama lengkap" :dense="dense" />
            </div>
            <div class="form-group">
              <q-item-label style="margin-top: 14px; margin-bottom: 5px; color: #666">Jenis Kelamin</q-item-label>
              <q-btn-toggle
                v-model="jk"
                toggle-color="primary"
                :options="[
                  {label: 'Laki-laki', value: 'L'},
                  {label: 'Perempuan', value: 'P'},

                ]"
              />
            </div>
            <div class="form-group">
              <q-input v-model="password" label="Password" :type="isPwd ? 'password' : 'text'" >
                <template v-slot:append>
                  <q-icon
                    :name="isPwd ? 'visibility_off' : 'visibility'"
                    class="cursor-pointer"
                    @click="isPwd = !isPwd"
                  />
                </template>
              </q-input>
              <q-input v-model="password_confirm" label="Confirm Password" :type="isPwd ? 'password' : 'text'" style="margin-bottom: 20px">
                <template v-slot:append>
                  <q-icon
                    :name="isPwd ? 'visibility_off' : 'visibility'"
                    class="cursor-pointer"
                    @click="isPwd = !isPwd"
                  />
                </template>
              </q-input>
            </div>
            <div class="form-actions">
              <q-separator style="margin-bottom: 10px; margin-top: 10px" />
              <button type="submit" style="background: #0190fe; border-color: #0190fe; cursor: pointer; padding: 6px; color: white; border-radius: 4px" data-style="expand-left">Register</button>
              <span class="register-link">
                <br>Tidak Menerima Link Aktivasi?<a href="/#/login" style="margin-left: 10px; color: #08f;">Klik disini</a>
              </span>
            </div>
          </form>
        </div>
      </div>

    </div>

  </div>
</template>

<script>
  import VueRecaptcha from 'vue-recaptcha';

  export default {
    name: "Register",

    components: {
      VueRecaptcha
    },

    data() {
      return {
        password: null,
        isPwd: true,
        dense: null,
        jk:null,
        password_confirm: null,
        email: null,
        nama: null,
        url_register: '/api/register',
        captchaResponse: null,
        captcha_key: "6LeenLoZAAAAAOxj2Hek9yzsrT6YMBHgcNrmrtU4"
      }
    },

    methods: {
      captchaExec: function (response) {
        this.captchaResponse = response
      },

      async doRegister () {
        this.$q.loading.show()
        await this.$recaptchaLoaded()
        this.captchaResponse = await this.$recaptcha('login')
        let pesan = "Captcha Error";

        let formData = new FormData();

        formData.append("name", this.nama);
        formData.append("email", this.email);
        formData.append("password", this.password);
        formData.append("c_password", this.password_confirm);
        formData.append("jk", this.jk);
        formData.append("captcha_token", this.captchaResponse);

        if (!this.nama || !this.email || !this.password || !this.password_confirm) {
          this.notifikasi("Tolong Lengkapi Form")
          this.$q.loading.hide()
        } else {
          if (!this.captchaResponse) {
            this.notifikasi("Selesaikan Captcha")
          } else {
            this.$q.loading.show();
            this.$axios.post(this.url_register, formData)

            .then(sukses => {
              let token = sukses.data.success.token
              localStorage.setItem("token", token)
              this.$q.loading.hide()
              this.$q.notify({
                message: "Berhasil Registrasi, Silahkan Cek Email untuk Verifikasi",
                position: "top",
                color: "green"
              })
              this.$router.push("/")
            })

            .catch(error => {
              let dataError = error.response.data.error
              for (let dataRo in dataError) {
                this.notifikasi(dataError[dataRo][0])
              }
              this.$q.loading.hide()
            })
          }
        }

      },

      notifikasi: function (pesanError) {
        this.$q.notify({
          position: "top",
          type: 'negative',
          message: pesanError
        })
      },
    }
  }
</script>

<style scoped>
  .cui-login-block-sidebar {
    display: block;
    /*position: absolute;*/
    width: 23.07rem;
    padding: 3.07rem;
    height: 550px;
    color: #fff;
  }
  .cui-login-block-sidebar-item {
    padding-left: 1.53rem;
    border-left: 2px solid #74708d;
    margin-bottom: 1.53rem;
    color: #f7efef;
  }

  .cui-login-block-form{
    padding: 3.07rem;
    padding-top: 10px;
    /*height: 550px;*/
  }

  .g-recaptcha {
    transform:scale(0.77);
    transform-origin:0 0;
  }
  #g-recaptcha {
    transform:scale(0.77);
    transform-origin:0 0;
  }
</style>
